using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace HelloWorldXNA
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        Texture2D texture;

        private List<Vector2> _locations = new List<Vector2>();

        private Vector2 _position = new Vector2(300, 190);
        private Color textureColor = Color.White;
        private Vector2 _speed = new Vector2(0, 0);

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            
            // Frame rate is 30 fps by default for Windows Phone.
            TargetElapsedTime = TimeSpan.FromTicks(333333);

            //force portrait orientation
            graphics.SupportedOrientations = DisplayOrientation.Portrait;
            graphics.PreferredBackBufferHeight = 800;
            graphics.PreferredBackBufferWidth = 480;

            TouchPanel.EnabledGestures = GestureType.Flick | GestureType.Tap;
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
            texture = Content.Load<Texture2D>("WP7");
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();


            #region demo 7_1
            //TouchCollection coll = TouchPanel.GetState();
            //foreach (var item in coll)
            //{
            //    this._locations.Add(item.Position);
            //}

            #endregion

            #region demo 7_2
            _speed.X = _speed.X > 0 ? (float)Math.Max(0, _speed.X - 0.1) : (float)Math.Min(0, _speed.X + 0.1);
            _speed.Y = _speed.Y > 0 ? (float)Math.Max(0, _speed.Y - 0.1) : (float)Math.Min(0, _speed.Y + 0.1);

            if (TouchPanel.IsGestureAvailable)
            {
                var gesture = TouchPanel.ReadGesture();
                switch (gesture.GestureType)
                {
                    case GestureType.Flick:
                        this._speed = new Vector2(gesture.Delta.X / 100, gesture.Delta.Y / 100);
                        break;
                    case GestureType.Tap:
                        if (textureColor == Color.White)
                            textureColor = Color.Red;
                        else
                            textureColor = Color.White;
                        break;
                    default:
                        break;
                }
            }

            _position.X += _speed.X;
            _position.Y += _speed.Y;
            _position.X = Math.Max(0, _position.X);
            _position.Y = Math.Max(0, _position.Y);

            _position.X = Math.Min(480 - 100, _position.X);
            _position.Y = Math.Min(800 - 200, _position.Y);

            #endregion


            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin(SpriteSortMode.BackToFront, BlendState.AlphaBlend);

            #region demo 7_1
            //foreach (var v in _locations)
            //{
            //    spriteBatch.Draw(texture, v, Color.White);
            //}
            #endregion

            #region demo 7_2
            spriteBatch.Draw(texture, _position, textureColor);
            #endregion
            
            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
